/* little test */

#include <stdio.h>

#include "parser.h"

int
main (void)
{
	t_netconf *tree;
	t_scheme *cs;
	t_iface *ci;
	t_alias *ca;
	t_provider *cp;
	t_opt *co;

	if ((tree = parse_file ("../net.conf")) == NULL) {
		printf ("error: %s", errstr);
	}
	else {
		printf ("tree\n");
		if (tree->demand) {
			printf ("  %c-> demand\n", (tree->schemes) ? '|' : '\\');
		}
		for (cp = tree->demand; cp; cp = cp->next) {
			printf ("  %c    %c-> provider %s\n", (tree->schemes) ? '|' : '\\',
			                                      (cp->next) ? '|' : '\\',
			                                      cp->name);
			for (co = cp->options; co; co = co->next) {
				printf ("  %c    %c     %c-> %s: %s\n", (cs->next) ? '|' : ' ',
				                                 (cp->next) ? '|' : ' ',
				                                 (co->next) ? '|' : '\\',
				                                 co->name, co->val);
			}
			printf ("  %c    %c\n", (tree->schemes) ? '|' : ' ',
			                        (cp->next) ? '|' : ' ');
		}
		printf ("  %c\n", (tree->schemes) ? '|' : ' ');
		for (cs = tree->schemes; cs; cs = cs->next) {
			printf ("  %c-> scheme %s\n", (cs->next) ? '|' : '\\',
			                              cs->name);
			for (ci = cs->iface; ci; ci = ci->next) {
				printf ("  %c     %c-> iface %s\n", (cs->next) ? '|' : ' ',
				                              (ci->next) ? '|' : '\\',
				                              ci->name);
				for (ca = ci->alias; ca; ca = ca->next) {
					printf ("  %c     %c     %c-> alias\n", (cs->next) ? '|' : ' ',
					                                        (ci->next) ? '|' : ' ',
					                                        (ca->next) ? '|' : '\\');

					for (co = ca->options; co; co = co->next) {
						printf ("  %c     %c     %c     %c-> %s: %s\n",
						               (cs->next) ? '|' : ' ',
						               (ci->next) ? '|' : ' ',
						               (ca->next) ? '|' : ' ',
						               (co->next) ? '|' : '\\',
						               co->name, co->val);
					}
					printf ("  %c     %c     %c\n",
					                (cs->next) ? '|' : ' ',
					                (ci->next) ? '|' : ' ',
					                (ca->next) ? '|' : ' ');

				}
			}
		}
	}

	return 0;
}
